function  modifyTree( nextNode)
global node;
global QTable;
global vectorLength;
global nodeIDCounter;
global nActions;
global rewardThereshold;
global penaltyThereshold;

temp = node(nextNode).mem(:,9)';
ep = find(temp >= 0);

if size(ep,2)>= rewardThereshold  % most of the pattern get reward
    node(nextNode).flag= 'L';
    node(nextNode).mem=[];
    % todo manni: what should we do for memory?

elseif size(ep,2)<= penaltyThereshold % most of the pattern get penalty
    % delete node from tree
    if nextNode~=1
        if node(nextNode).childID>0
            for childCount=1: size(node(node(nextNode).parent).childs,2)
                node(node(nextNode).parent).childs(childCount).ID=node(nextNode).childID;
                node(node(nextNode).parent).childs(childCount)=[];
            end
        end
        stateNum = find(QTable(:,1)'== nextNode);
        QTable = removerows(QTable,stateNum);
        node(nextNode).mem=[];
    end

else% aliasing
    %----------- calculate entropy-----------------------
    prob(9).valPositive = size(ep,2);
    prob(9).valNegative = size(temp,2)-size(ep,2);
    entropyTotal = - (prob(9).valPositive/size(temp,2))*log2(prob(9).valPositive/size(temp,2))-...
        (prob(9).valNegative/size(temp,2))*log2(prob(9).valNegative/size(temp,2));

    prob(1).attributes=[]; prob(2).attributes=[]; prob(3).attributes=[]; prob(4).attributes=[];
    prob(5).attributes=[]; prob(6).attributes=[]; prob(7).attributes=[]; prob(8).attributes=[];

    for memCount = 1: size(node(nextNode).mem,1)
        for dirCounter =1: 8
            valAttrib = node(nextNode).mem(memCount,dirCounter);
            attribPos = find( prob(dirCounter).attributes == valAttrib);
            if size(attribPos,2)==0
                if (attribPos==0)
                    attribPos=1;
                end
                prob(dirCounter).attributes = [ prob(dirCounter).attributes   valAttrib ];
                %                 prob(dirCounter).attr(attribPos).valAttrib = prob(dirCounter).attributes(attribPos);
                attribPos = size( prob(dirCounter).attributes ,2);
                prob(dirCounter).attr(attribPos).valPositive=0;
                prob(dirCounter).attr(attribPos).valNegative=0;
            end
            if node(nextNode).mem(memCount,9) >= 0
                prob(dirCounter).attr(attribPos).valPositive = prob(dirCounter).attr(attribPos).valPositive + 1  ;
            else
                prob(dirCounter).attr(attribPos).valNegative= prob(dirCounter).attr(attribPos).valNegative + 1  ;
            end
        end
    end
    %------- calculate gainRatio
    for dirCounter =1: 8
        entropy =0;
        sum=0;
        for attribPos=1: size(prob(dirCounter).attributes,1)
            pos = prob(dirCounter).attr(attribPos).valNegative;
            neg = prob(dirCounter).attr(attribPos).valPositive;
            total = pos + neg;
            if neg ~=0 && pos ~=0
                sum = sum  + (total/size(temp,2))*((- pos/total) * log2(pos/total)+ (- neg/total) * log2(neg/total));
            elseif neg ==0
                sum = sum  + (total/size(temp,2))*((- neg/total) * log2(neg/total));
            elseif pos ==0
                sum = sum  + (total/size(temp,2))*( (- neg/total) * log2(neg/total));
            end
        end

        gainRatio(dirCounter )= entropyTotal -sum;
    end

    [val selectedAttrib]= max(gainRatio);
    node(nextNode).direction = selectedAttrib;
    stateNum = find(QTable(:,1)'== nextNode);
    QTable = removerows(QTable,stateNum);

    for childCounter = 1: size( prob(selectedAttrib).attributes,2 )
        nodeIDCounter = nodeIDCounter+1;
        node(nextNode).childs(childCounter).ID = nodeIDCounter;
        node(nextNode).childs(childCounter).codebook = prob(selectedAttrib).attributes(childCounter);

        node(nodeIDCounter).ID = nodeIDCounter;
        node(nodeIDCounter).childID = childCounter;
        node(nodeIDCounter).parent = nextNode;
        node(nodeIDCounter).length = vectorLength; % Initial search range is 30 pixels
        node(nodeIDCounter).direction =1;

        QTable = [QTable ; nodeIDCounter,  ones(1 , nActions)/nActions];
    end
    %---------------modify tree
    node(nextNode).mem=[];
end

end% function
